Summary: A version control system.
Name: cvs
Version: 1.12.13
Release: 1tr
License: GPL
Group: Trustix Official
Source: https://ccvs.cvshome.org/files/documents/19/872/cvs-%{version}.tar.bz2
Source1: cvspserver.xinetd

URL: http://www.cvshome.org/
Patch0: cvs-1.12.12-authserver.patch
Patch1: cvs-1.11.2-cvspass.patch
Patch2: cvs-1.11.1p1-bs.patch
Patch3: cvs-1.12.12-tmp.patch
Prereq: htmlinfo
PreReq: setup >= 2.2.9-7tr
Buildroot: %{_tmppath}/%{name}-root
BuildRequires: zlib-devel, texinfo, tcsh

%description
CVS (Concurrent Version System) is a version control system that can
record the history of your files (usually, but not always, source
code). CVS only stores the differences between versions, instead of
every version of every file you have ever created. CVS also keeps a log
of who, when, and why changes occurred.

CVS is very helpful for managing releases and controlling the
concurrent editing of source files among multiple authors. Instead of
providing version control for a collection of files in a single
directory, CVS provides version control for a hierarchical collection
of directories consisting of revision controlled files. These
directories and files can then be combined together to form a software
release.


%package contrib
Summary: code scripts contributed for cvs
Group: Trustix Official
Requires: cvs = %{version}-%{release}

%description contrib
The contrib package contains code/scripts that were sent to the cvs
maintainers by contributors around the world. They are unsupported and
you might not even work.

USE AT YOUR OWN RISK -- and all that stuff.

%package pserver
Summary: Config files necessary to run CVS in pserver mode.
Group: Trustix Official
Requires: xinetd

%description pserver
Config files for xinetd.d that are necessary to run CVS in pserver
mode.


%prep
%setup -q
%patch0 -p1 -b .authserver
%patch1 -p1 -b .cvspass
%patch2 -p1 -b .bs
%patch3 -p1

%build
%configure --without-gssapi
make LDFLAGS=-s

if [ `id -u` -ne 0 ] ; then
	make check
fi

cd doc
makeinfo --html --no-split cvs.texinfo
makeinfo --html --no-split cvsclient.texi

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
%makeinstall

install -d -o root -g root -m 755 $RPM_BUILD_ROOT/%{_datadir}/html/%{name}/
install -m 644 doc/%{name}.html  $RPM_BUILD_ROOT/%{_datadir}/html/%{name}/
install -d -o root -g root -m 755 $RPM_BUILD_ROOT/%{_datadir}/html/cvsclient/
install -m 644 doc/cvsclient.html  $RPM_BUILD_ROOT/%{_datadir}/html/cvsclient/

# remove documentation from install root
rm $RPM_BUILD_ROOT/%{_datadir}/%{name}/contrib/README
rm $RPM_BUILD_ROOT/%{_datadir}/%{name}/contrib/intro.doc

mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d/
mkdir -p $RPM_BUILD_ROOT/home/cvs/
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT/etc/xinetd.d/cvspserver


%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%pre

if [ -z "`getent group cvs`" ] ; then
        /usr/sbin/groupadd -g 17 cvs
fi
if [ -z "`getent passwd cvs`" ] ; then
        /usr/sbin/useradd -u 17 -g cvs -M -d /no/dir -s /bin/false cvs
fi


%post
/usr/sbin/htmlinfo_update.sh

## Hack to fix ownership issue

if [ -d /home/cvs ];then

OWNER=`/usr/bin/stat -c %U /home/cvs/`
GROUP=`/usr/bin/stat -c %G /home/cvs/`

if [ $OWNER="cvsuser" -a $GROUP="cvsuser" ];then
        /bin/chown -R cvs:cvs /home/cvs
fi

fi

%postun
/usr/sbin/htmlinfo_update.sh

%files
%defattr(-,root,root,0755)
%doc AUTHORS BUGS COPYING* DEVEL-CVS FAQ HACKING MINOR-BUGS NEWS
%doc PROJECTS TODO README
%{_bindir}/cvs
%{_bindir}/cvsbug
%{_mandir}/*/*
%{_datadir}/html/%{name}/*
%{_datadir}/html/cvsclient/*

%files contrib
%defattr(-,root,root,0755)
%doc contrib/README contrib/intro.doc
%{_bindir}/rcs2log
%{_datadir}/%{name}
 
%files pserver
%defattr(-,root,root,0755)
%config(noreplace) /etc/xinetd.d/cvspserver
%attr(0755,cvs,cvs) %dir /home/cvs

%changelog
* Wed Oct  5 2005 Nived Gopalan <nived at comodo dot com> 1.12.13-1tr
- New Upstream.
- SECURITY Fix: Two vulnerabilities in CVS, which potentially can be
  exploited by malicious people to cause a DoS (Denial of Service) and
  compromise a vulnerable system, has been fixed.

  The vulnerabilities are caused due to the use of a vulnerable version
  of zlib (CAN-2004-0797 and CAN-2005-2096).

* Mon Sep 19 2005 Erlend Midttun <erlendbm at trustix dot org> 1.12.12-5tr
- Added missing disable=yes in xinetd.d/cvspserver
- Added missing %config(noreplace) in xinetd.d/cvspserver

* Fri Aug 26 2005 Nived Gopalan <nived at comodo dot com> 1.12.12-4tr
- Security Fix: Josh Bressers has reported a security issue in cvs, which
  potentially can be exploited by malicious, local users to perform certain
  actions on a vulnerable system with escalated privileges.

  The security issue is caused due to insecure temporary file usage by the cvsbug.in
  script when saving temporary output to "/tmp".

* Wed Aug 10 2005 Nived Gopalan <nived at comodo dot com> 1.12.12-3tr
- Added ugly hack to fix ownership issues with /home/cvs.
- Fix %post section and clean up.

* Tue Aug  9 2005 Nived Gopalan <nived at comodo dot com> 1.12.12-2tr
- Added config files for xinetd.d that are necessary to run CVS in pserver mode.

* Tue Apr 19 2005 Erlend Midttun <erlendbm at trustix dot org> 1.12.12-1tr
- SECURITY: New upstream.  From the NEWS file:
- Thanks to a report from Alen Zukich <alen.zukich@klocwork.com>, several minor
  security issues have been addressed.  One was a buffer overflow that is
  potentially serious but which may not be exploitable, assigned CAN-2005-0753
  by the Common Vulnerabilities and Exposures Project
  <http://www.cve.mitre.org>.  Other fixes resulting from Alen's report include
  repair of an arbitrary free with no known exploit and several plugged memory
  leaks and potentially freed NULL pointers which may have been exploitable for
  a denial of service attack.

- Thanks to a report from Craig Monson <craig@malachiarts.com>, minor
  potential vulnerabilities in the contributed Perl scripts have been fixed.
  The confirmed vulnerability could allow the execution of arbitrary code on
  the CVS server, but only if a user already had commit access and if one of
  the contrib scripts was installed improperly, a condition which should have
  been quickly visible to any administrator.  The complete description of the
  problem is here: <https://ccvs.cvshome.org/issues/show_bug.cgi?id=224>.  If
  you were making use of any of the contributed trigger scripts on a CVS
  server, you should probably still replace them with the new versions, to be
  on the safe side.

* Thu Jun 10 2004 Chr. Toldnes <christht at trustix dot org> 1.12.9-1ct
- New upstream version: 1.12.9

* Wed Apr 14 2004 Oystein Viggen <oysteivi at trustix dot com> 1.12.7-1tr
- New upstream

* Mon Mar  8 2004 Chr. Toldnes <christht at trustix dot org>
- Rebuilt for TSL 2.1

* Mon Dec 15 2003 Goetz Bock <bg at trustix dot org> 1.11.10-1bg
- new upstream: 1.11.10, sec fixes

* Tue Dec  9 2003 Goetz Bock <bg at trustix dot org> 1.11.9-1bg
- new upstream: 1.11.9

* Mon Aug 18 2003 Goetz Bock <bock at trustix dot org> 1.11.6-3bg
- requires (t)csh to build correectly

* Mon Aug 18 2003 Goetz Bock <bock at trustix dot org> 1.11.6-2bg
- rebuild for Cloud (aka Trustix 2.0) - Contrib
 
* Mon Jul 21 2003 Goetz Bock <bock at trustix dot org> 1.11.6-1bg
- new upstream: 1.11.6
- removed patch0 (cvs-1.11.2-mktemp.patch) and 
  patch1 (cvs-1.11.5-krb4.patch) as they are now included in the src.
- split contrib stuff into own package (as it needs csh)

* Sun Feb 24 2003 Goetz Bock <bock at trustix dot org> 1.11.5-5bg
- build on TSL1.5, try to cheat with noauto* script

* Mon Dec 16 2002 Goetz Bock <bock at trustix dot org> 1.11.5-4bg
- listen to Shime: cvsclient got own html directory
- removed .ps files (we have .html and manpages)

* Mon Dec 16 2002 Goetz Bock <bock at trustix dot org> 1.11.5-3bg
- fixed stupid typo

* Mon Dec 16 2002 Goetz Bock <bock at trustix dot org> 1.11.5-2bg
- changed info to htmlinfo

* Tue Jun 25 2002 Goetz Bock <bock at trustix dot org> 1.11.5-1bg
- rebuild for Trustiix Secure Linux
- based on some version after 1.11.2-3 from readhat.com
